import "dart:async";

import "package:shelf/shelf_io.dart" as io;
import "package:shelf_route/shelf_route.dart" as routing;

import "package:eventsource/publisher.dart";
import "package:shelf_eventsource/shelf_eventsource.dart";

main() {
  // create the publisher object that will manage event publishing to
  // subscribers
  EventSourcePublisher publisher = new EventSourcePublisher(cacheCapacity: 100);

  // generate some dummy events
  generateEvents(publisher);

  // create a shelf handler
  var handler = eventSourceHandler(publisher);

  // create a router to serve the different event sources
  var router = routing.router();
  router.get("/events", handler);

  // serve localhost with our router
  io.serve(router.handler, "localhost", 8080);
}

generateEvents(EventSourcePublisher publisher) {
  int id = 0;
  new Timer.periodic(const Duration(seconds: 3), (timer) {
    if (id == 5) {
      timer.cancel();
      // broadcast last message to both channels and close them
      publisher.add(
          new Event(id: "$id", event: "goodbye", data: "Goodbye all!"));
      publisher.closeAllChannels();
      return;
    }
    // publish an event on the default channel
    publisher
        .add(new Event.message(id: "$id", data: "Always the same message?"));
    id++;
  });
}
